/*
 * ICFP 2002 Programming Contest
 * Entry by Seth Bruder
 *
 */

package sethbruder.icfp2002.entry;

import java.io.*;

public final class Debug {

	private static boolean debugOn = false;
	private static String lastLineRead = null;

	public static void activate() {
		debugOn = true;
	}

	public static void println(Object s) {
		print(s + "\n");
	}

	public static void print(Object s) {
		if (!debugOn) return;

		System.out.print(s.toString());
	}

	public static String readLine(BufferedReader in) throws Exception {
		String s = in.readLine();
		lastLineRead = s;
		return s;
	}

	public static String getLastLineRead() { return lastLineRead; }
}
