/*
 * ICFP 2002 Programming Contest
 * Entry by Seth Bruder
 *
 */

package sethbruder.icfp2002.entry;

import java.util.LinkedList;
import java.util.StringTokenizer;

public final class PlayerMoveOutcome {

	public final int playerId;
	public final Move[] moves;

	public PlayerMoveOutcome(String outcomeString) throws Exception {

		StringTokenizer st = new StringTokenizer(outcomeString, " ", false);
		this.playerId = Integer.valueOf(st.nextToken()).intValue();

		char c;
		int i, j;
		LinkedList l = new LinkedList();
		while (st.hasMoreTokens()) {
			c = st.nextToken().charAt(0);
			switch (c) {
				case 'N':
					l.add(Move.NORTH_MOVE);
					break;
				case 'S':
					l.add(Move.SOUTH_MOVE);
					break;
				case 'E':
					l.add(Move.EAST_MOVE);
					break;
				case 'W':
					l.add(Move.WEST_MOVE);
					break;
				case 'P':
					i = Integer.valueOf(st.nextToken()).intValue();
					l.add(new Move(Move.PICK, i));
					break;
				case 'D':
					i = Integer.valueOf(st.nextToken()).intValue();
					l.add(new Move(Move.DROP, i));
					break;
				case 'X':
					i = Integer.valueOf(st.nextToken()).intValue();
					st.nextToken();
					j = Integer.valueOf(st.nextToken()).intValue();
					l.add(new Move(Move.POSITION, i, j));
					break;
				default:
					throw new Exception("Could not parse move outcome list.");
			}
		}

		this.moves = (Move[])l.toArray(new Move[0]);
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();

		sb.append("id=" + playerId + " moves=[");
		for (int i = 0; i < moves.length; i++) {
			if (i > 0) sb.append(", ");
			sb.append(moves[i]);
		}
		sb.append("]");

		return sb.toString();
	}
}
